require('luci.sys')
require('luci.util')
local s=require('luci.model.ipkg')
local e=require'nixio.fs'
local i=require'luci.model.uci'.cursor()
local t,e
local d=(luci.sys.call('pidof rclone > /dev/null')==0)
local a=''
local r=i:get('rclone','config','port')
local h=i:get('rclone','config','addr_type')
local n=''
if h=='local'then
n=i:get('network','loopback','ipaddr')
elseif h=='lan'then
n=i:get('network','lan','ipaddr')
else
n='[ip]'
end
if d then
a='<b><font color="green">'..translate('rclone running')..'</font></b>'
address_msg=translate('rclone address')..' : http://'..n..':'..r..'<br/> <br/>'
else
a='<b><font color="red">'..translate('rclone not run')..'</font></b>'
address_msg=''
end
if s.installed("rclone-webui-react")and s.installed("rclone-ng")then
t=
Map(
'rclone',
translate('Rclone'),
translate('Rclone ("rsync for cloud storage") is a command line program to sync root/usr/bin and directories to and from different cloud storage providers.')..
' <br/> <br/> '..translate('rclone state')..' : '..a..'<br/> <br/>'
..address_msg..
translate('Installed Web Interface')..
'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="cbi-button" style="margin: 0 5px;" value=" '..
translate('Webui React')..
" \" onclick=\"window.open('http://'+window.location.hostname+'/rclone-webui-react')\"/>"..
'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="cbi-button" style="margin: 0 5px;" value=" '..
translate('RcloneNg')..
" \" onclick=\"window.open('http://'+window.location.hostname+'/RcloneNg')\"/> <br/><br/>"
)
elseif s.installed("rclone-webui-react")then
t=
Map(
'rclone',
translate('Rclone'),
translate('Rclone ("rsync for cloud storage") is a command line program to sync root/usr/bin and directories to and from different cloud storage providers.')..
' <br/> <br/> '..translate('rclone state')..' : '..a..'<br/> <br/>'
..address_msg..
translate('Installed Web Interface')..
'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="cbi-button" style="margin: 0 5px;" value=" '..
translate('Webui React')..
" \" onclick=\"window.open('http://'+window.location.hostname+'/rclone-webui-react')\"/>"
)
elseif s.installed("rclone-ng")then
t=
Map(
'rclone',
translate('Rclone'),
translate('Rclone ("rsync for cloud storage") is a command line program to sync root/usr/bin and directories to and from different cloud storage providers.')..
' <br/> <br/> '..translate('rclone state')..' : '..a..'<br/> <br/>'
..address_msg..
translate('Installed Web Interface')..
'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" class="cbi-button" style="margin: 0 5px;" value=" '..
translate('RcloneNg')..
" \" onclick=\"window.open('http://'+window.location.hostname+'/RcloneNg')\"/> <br/><br/>"
)
else
t=
Map(
'rclone',
translate('Rclone'),
translate('Rclone ("rsync for cloud storage") is a command line program to sync root/usr/bin and directories to and from different cloud storage providers.')..
' <br/> <br/> '..translate('rclone state')..' : '..a..'<br/> <br/>'
..address_msg
)
end
e=t:section(TypedSection,'global',translate('global'))
e.addremove=false
e.anonymous=true
enable=e:option(Flag,'enabled',translate('run Rclone as daemon'))
enable.rmempty=false
e=t:section(TypedSection,'conf',translate('configure'))
e.addremove=false
e.anonymous=true
o=e:option(ListValue,'addr_type',translate('listen address'))
o:value('local',translate('localhost address'))
o:value('lan',translate('local network address'))
o:value('all',translate('all address'))
o.default='lan'
o.rmempty=false
o=e:option(Value,'port',translate('listen port'))
o.placeholder=5572
o.default=5572
o.datatype='port'
o.rmempty=false
o=e:option(Value,'config_path',translate('rclone configuration file path'))
o.placeholder='/etc/rclone/rclone.conf'
o.default='/etc/rclone/rclone.conf'
o.rmempty=false
o.description=translate("Recommand: run ")..
"<span style=\"background: lightgray;border-radius: 4px;padding-left: 4px;padding-right: 4px;\">rclone config --config rclone.conf</span>"..
translate(" to setup configuration on pc,").."</br>"..translate("than updaload configuration to here.")
o=e:option(Button,"config_download",translate("download configuration"))
o.inputtitle=translate("download")
o.inputstyle="apply"
o.write=function()
Download()
end
function Download()
local t,e
t=nixio.open(i:get('rclone','config','config_path'),"r")
luci.http.header('Content-Disposition','attachment; filename="rclone.conf"')
luci.http.prepare_content("application/octet-stream")
while true do
e=t:read(nixio.const.buffersize)
if(not e)or(#e==0)then
break
else
luci.http.write(e)
end
end
t:close()
luci.http.close()
end
o=e:option(Value,'username',translate('username'))
o.placeholder='admin'
o.default='admin'
o.rmempty=false
o=e:option(Value,'password',translate('password'))
o.password=true
o.placeholder='admin'
o.default='admin'
o.rmempty=false
e=t:section(TypedSection,'proxy',translate('proxy'))
e.addremove=false
e.anonymous=true
e.description="<a style=\"color:#fb6340;\" href=\"#\" onclick=\"window.open('https://rclone.org/faq/#can-i-use-rclone-with-an-http-proxy')\">"
..translate("FAQ").."</a>"
enable=e:option(Flag,'enabled',translate('enable proxy'))
enable.rmempty=false
o=e:option(Value,'proxy_addr',translate('proxy address'))
o.placeholder='socks5://127.0.0.1:1080'
o.default='socks5://127.0.0.1:1080'
o.rmempty=false
o.description=translate("The content of the variable is protocol://server:port. The protocol value is commonly either http or socks5.")
e=t:section(TypedSection,'log',translate('log'))
e.addremove=false
e.anonymous=true
o=e:option(Value,'path',translate('path'))
o.placeholder='/var/log/rclone/output'
o.default='/var/log/rclone/output'
o.rmempty=false
return t
